VST 3 Examples: VoiceBase< numValues, SamplePrecision, numChannels, GlobalParameterStorage > Class Template Reference
Author: Steinberg

VST 3 Examples VST 3.7 SDK for developing VST plug-in

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
VoiceBase< numValues, SamplePrecision, numChannels, GlobalParameterStorage > Class Template Reference

Example Voice class for the Steinberg::Vst::VoiceProcessorImplementation. More...

`#include <voicebase.h>`

## Public Member Functions
int32 | getNoteId () const
| Returns the current note id of this voice.
virtual void | setGlobalParameterStorage (GlobalParameterStorage *globalParameters)
| Sets a new GlobalParameterStorage.
virtual void | setSampleRate (ParamValue sampleRate)
| Sets the sampleRate.
float | getSampleRate () const
| Returns the sampleRate.
virtual void | setNoteExpressionValue (int32 index, ParamValue value)
virtual void | noteOn (int32 pitch, ParamValue velocity, float tuning, int32 sampleOffset, int32 noteId)
virtual void | noteOff (ParamValue velocity, int32 sampleOffset)
virtual void | reset ()

## Protected Member Functions
| VoiceBase ()
| VoiceBase (const VoiceBase &vb)
virtual | ~VoiceBase ()

## Protected Attributes
GlobalParameterStorage * | globalParameters
int32 | noteId
int32 | pitch
int32 | noteOnSampleOffset
int32 | noteOffSampleOffset
float | tuning {0}
ParamValue | sampleRate
ParamValue | noteOnVelocity
ParamValue | noteOffVelocity
ParamValue | values [numValues]

## Detailed Description

template<uint32 numValues, class SamplePrecision, uint32 numChannels, class GlobalParameterStorage>
class Steinberg::Vst::VoiceBase< numValues, SamplePrecision, numChannels, GlobalParameterStorage >

Example Voice class for the Steinberg::Vst::VoiceProcessorImplementation.

Implementation classes need to implement the following additional method:

bool process (SamplePrecision* outputBuffers[numChannels], int32 numSamples);
Steinberg::int32
int32_t int32

## Constructor & Destructor Documentation

## ◆ VoiceBase() [1/2]

template<uint32 numValues, class SamplePrecision, uint32 numChannels, class GlobalParameterStorage>

VoiceBase | ( |  | ) |
| protected

## ◆ VoiceBase() [2/2]

template<uint32 numValues, class SamplePrecision, uint32 numChannels, class GlobalParameterStorage>

VoiceBase | ( | const VoiceBase< numValues, SamplePrecision, numChannels, GlobalParameterStorage > & | vb | ) |
| protected

## ◆ ~VoiceBase()

template<uint32 numValues, class SamplePrecision, uint32 numChannels, class GlobalParameterStorage>

~VoiceBase | ( |  | ) |
| protectedvirtual

## Member Function Documentation

## ◆ getNoteId()

template<uint32 numValues, class SamplePrecision, uint32 numChannels, class GlobalParameterStorage>

int32 getNoteId | ( |  | ) | const
| inline

Returns the current note id of this voice.

## ◆ setGlobalParameterStorage()

template<uint32 numValues, class SamplePrecision, uint32 numChannels, class GlobalParameterStorage>

virtual void setGlobalParameterStorage | ( | GlobalParameterStorage * | globalParameters | ) |
| inlinevirtual

Sets a new GlobalParameterStorage.

## ◆ setSampleRate()

template<uint32 numValues, class SamplePrecision, uint32 numChannels, class GlobalParameterStorage>

virtual void setSampleRate | ( | ParamValue | sampleRate | ) |
| inlinevirtual

Sets the sampleRate.

Reimplemented in Voice< SamplePrecision >.

## ◆ getSampleRate()

template<uint32 numValues, class SamplePrecision, uint32 numChannels, class GlobalParameterStorage>

float getSampleRate | ( |  | ) | const
| inline

Returns the sampleRate.

## ◆ setNoteExpressionValue()

template<uint32 numValues, class SamplePrecision, uint32 numChannels, class GlobalParameterStorage>

virtual void setNoteExpressionValue | ( | int32 | index,
|  | ParamValue | value )
| inlinevirtual

Reimplemented in Voice< SamplePrecision >.

## ◆ noteOn()

template<uint32 numValues, class SamplePrecision, uint32 numChannels, class GlobalParameterStorage>

void noteOn | ( | int32 | pitch,
|  | ParamValue | velocity,
|  | float | tuning,
|  | int32 | sampleOffset,
|  | int32 | noteId )
| virtual

Reimplemented in Voice< SamplePrecision >.

## ◆ noteOff()

template<uint32 numValues, class SamplePrecision, uint32 numChannels, class GlobalParameterStorage>

void noteOff | ( | ParamValue | velocity,
|  | int32 | sampleOffset )
| virtual

Reimplemented in Voice< SamplePrecision >.

## ◆ reset()

template<uint32 numValues, class SamplePrecision, uint32 numChannels, class GlobalParameterStorage>

virtual void reset | ( |  | ) |
| inlinevirtual

Reimplemented in Voice< SamplePrecision >.

## Member Data Documentation

## ◆ globalParameters

template<uint32 numValues, class SamplePrecision, uint32 numChannels, class GlobalParameterStorage>

GlobalParameterStorage* globalParameters
| protected

## ◆ noteId

template<uint32 numValues, class SamplePrecision, uint32 numChannels, class GlobalParameterStorage>

int32 noteId
| protected

## ◆ pitch

template<uint32 numValues, class SamplePrecision, uint32 numChannels, class GlobalParameterStorage>

int32 pitch
| protected

## ◆ noteOnSampleOffset

template<uint32 numValues, class SamplePrecision, uint32 numChannels, class GlobalParameterStorage>

int32 noteOnSampleOffset
| protected

## ◆ noteOffSampleOffset

template<uint32 numValues, class SamplePrecision, uint32 numChannels, class GlobalParameterStorage>

int32 noteOffSampleOffset
| protected

## ◆ tuning

template<uint32 numValues, class SamplePrecision, uint32 numChannels, class GlobalParameterStorage>

float tuning {0}
| protected

## ◆ sampleRate

template<uint32 numValues, class SamplePrecision, uint32 numChannels, class GlobalParameterStorage>

ParamValue sampleRate
| protected

## ◆ noteOnVelocity

template<uint32 numValues, class SamplePrecision, uint32 numChannels, class GlobalParameterStorage>

ParamValue noteOnVelocity
| protected

## ◆ noteOffVelocity

template<uint32 numValues, class SamplePrecision, uint32 numChannels, class GlobalParameterStorage>

ParamValue noteOffVelocity
| protected

## ◆ values

template<uint32 numValues, class SamplePrecision, uint32 numChannels, class GlobalParameterStorage>

ParamValue values[numValues]
| protected

Empty

Copyright © Steinberg Media Technologies GmbH. All Rights Reserved. This documentation is under this license.